Bug 1012133 - periodic.stp doesn't work on rhel7
periodic.stp doesn't work on rhel7
Status: CLOSED CURRENTRELEASE
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: systemtap (Show other bugs)
7.0
All Linux
unspecified Severity medium
: beta
: ---
Assigned To: Frank Ch. Eigler
Martin Cermak
: Rebase
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-09-25 15:30 EDT by Jeremy Eder
Modified: 2014-06-18 00:17 EDT (History)
6 users (show)

See Also:
Fixed In Version: systemtap-2.4-1.el7
Doc Type: Rebase: Bug Fixes and Enhancements
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-06-13 07:59:12 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Comment 2 William Cohen 2013-10-09 15:27:18 EDT
With the current nightly compose it periodic.stp worked.


[wcohen@dhcp129-131 profiling]$ uname -r
3.10.0-33.el7.x86_64
[wcohen@dhcp129-131 profiling]$ rpm -q systemtap
systemtap-2.3-1.el7.x86_64
[wcohen@dhcp129-131 profiling]$ sudo stap  -v --all-modules periodic.stpPass 1: parsed user script and 108 library script(s) using 217724virt/35096res/3024shr/32956data kb, in 120usr/10sys/437real ms.
Pass 2: analyzed script: 3 probe(s), 11 function(s), 4 embed(s), 4 global(s) using 457984virt/129288res/4164shr/125676data kb, in 650usr/180sys/830real ms.
Pass 3: translated to C into "/tmp/stap83LIsY/stap_73790cd0c01e134dfbc76d152c13077e_11121_src.c" using 594328virt/191192res/30324shr/125676data kb, in 3120usr/60sys/3194real ms.
Pass 4: compiled C into "stap_73790cd0c01e134dfbc76d152c13077e_11121.ko" in 2520usr/240sys/2448real ms.
Pass 5: starting run.
#monitoring timer periods (press control-c for output)
^C#type   function                                            period(us)     count
kernel  0xffffffffa08e8f60 [stap_73790cd0c01e134dfbc76d152        1000      3117
kernel  0xffffffffa08e8f60 [stap_73790cd0c01e134dfbc76d152        1000      3117
kernel  0xffffffffa08e8f60 [stap_73790cd0c01e134dfbc76d152        1000      3117
kernel  0xffffffffa08e8f60 [stap_73790cd0c01e134dfbc76d152        1000      3117
kernel  0xffffffffa08e8f60 [stap_73790cd0c01e134dfbc76d152        1000      3114
kernel  0xffffffffa08e8f60 [stap_73790cd0c01e134dfbc76d152        1001      3113
kernel  0xffffffffa08e8f60 [stap_73790cd0c01e134dfbc76d152        1007      3095
kernel  0xffffffffa08e8f60 [stap_73790cd0c01e134dfbc76d152        1007      3094
kernel  intel_pstate_timer_func+0x0/0x2c0 [kernel]                9999       311
kernel  0xffffffffa08e81f0 [stap_73790cd0c01e134dfbc76d152        9999       311
kernel  intel_pstate_timer_func+0x0/0x2c0 [kernel]                9999       311
kernel  intel_pstate_timer_func+0x0/0x2c0 [kernel]               10003       310
kernel  intel_pstate_timer_func+0x0/0x2c0 [kernel]               10003       310
kernel  intel_pstate_timer_func+0x0/0x2c0 [kernel]               10000       310
kernel  intel_pstate_timer_func+0x0/0x2c0 [kernel]                9999       310
kernel  intel_pstate_timer_func+0x0/0x2c0 [kernel]               10000       310
kernel  intel_pstate_timer_func+0x0/0x2c0 [kernel]                9999       310
kernel  0xffffffffa08e88a0 [stap_73790cd0c01e134dfbc76d152       20006       154
process rcu_sched(9)                                            426009         7
work_q  vmstat_update                                          1000022         2
work_q  vmstat_update                                           999963         2
work_q  vmstat_update                                          1000001         2
work_q  vmstat_update                                          1000005         2
work_q  vmstat_update                                           999974         2
work_q  vmstat_update                                          1000022         2
work_q  sync_cmos_clock                                         999997         2
work_q  vmstat_update                                          1000010         1
kernel  tcp_write_timer+0x0/0x70 [kernel]                       233907         1
kernel  e1000_watchdog+0x0/0x30 [e1000e]                       2000002         1
work_q  vmstat_update                                          1000002         1
work_q  disk_events_workfn                                     2047971         1
Pass 5: run completed in 10usr/40sys/3431real ms.
[wcohen@dhcp129-131 profiling]$ 


However, on fedora 19 can see a failure in the same way:

[wcohen@santana profiling]$ uname -r
3.11.2-201.fc19.x86_64
[wcohen@santana profiling]$ rpm -q systemtap
systemtap-2.3-1.fc19.x86_64
[wcohen@santana profiling]$  sudo stap -v --all-modules  periodic.stp
Pass 1: parsed user script and 157 library script(s) using 377752virt/192748res/3040shr/192984data kb, in 870usr/40sys/916real ms.
semantic error: while resolving probe point: identifier 'kernel' at periodic.stp:12:7
        source: probe kernel.trace("timer_expire_entry")
                      ^

semantic error: no match
Pass 2: analyzed script: 2 probe(s), 145 function(s), 3 embed(s), 4 global(s) using 394620virt/207936res/5716shr/205276data kb, in 200usr/280sys/484real ms.
Pass 2: analysis failed.  [man error::pass2]
Comment 3 Frank Ch. Eigler 2013-10-12 15:40:46 EDT
On 3.11.3-201.fc19.x86_64, the timer_expire_entry tracepoint is fine, and periodic.stp works.
Comment 9 Frank Ch. Eigler 2013-10-12 20:47:52 EDT
(My guess is that your machine is lacking kernel-debuginfo, and the script
does not try to back down to synthetic debuginfo for the @cast operations;

   @cast(data[timer], "struct work_struct", "kernel<linux/workqueue.h>")->func

and similar for task_string ("kernel<linux/sched.h>") might make it work.)
Comment 10 Frank Ch. Eigler 2013-10-12 20:59:10 EDT
Please see [1] for a possible fix.

[1] http://www.sourceware.org/git/gitweb.cgi?p=systemtap.git;a=commitdiff;h=c87d7815ccd130c81fcabe0bc9f7e1decaca615b
Comment 17 Ludek Smid 2014-06-13 07:59:12 EDT
This request was resolved in Red Hat Enterprise Linux 7.0.

Contact your manager or support representative in case you have further questions about the request.

Note You need to log in before you can comment on or make changes to this bug.